if select(3, UnitClass("player")) ~= 9 then return end -- Only load when playing a warlock
local Whipped = _G.Whipped
local tinsert, sformat = table.insert, string.format -- DEBUG: sformat
local COMBATLOG_OBJECT_AFFILIATION_MINE = COMBATLOG_OBJECT_AFFILIATION_MINE
local Bar, TopFrame = 1, 1
local Demons = Whipped.Demons
local Imps = Demons.Imps

-- Frames
-- Delete a bunch of these frames when Fragment of the Dark Star becomes useless
-- Also update the Demons.Imps.HoG table to fit the entries with the amount of frames
Whipped.Frame_Imps_1 = CreateFrame("StatusBar", "Imps_1", Whipped.MasterFrame)
local Frame_Imps_1 = Whipped.Frame_Imps_1
local Frame_Imps_2 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_3 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_4 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_5 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_6 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_7 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_8 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_9 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_10 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_11 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_12 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_13 = CreateFrame("StatusBar", nil, Whipped.MasterFrame)
local Frame_Imps_Icon = CreateFrame("Frame", nil, Whipped.MasterFrame)
local ImpFrameList = {
	Frame_Imps_1, Frame_Imps_2, Frame_Imps_3, Frame_Imps_4, Frame_Imps_5,
	Frame_Imps_6, Frame_Imps_7, Frame_Imps_8, Frame_Imps_9, Frame_Imps_10,
	Frame_Imps_11, Frame_Imps_12, Frame_Imps_13}
Whipped.ImpFrameListSize = #ImpFrameList
local ImpFrameListSize = Whipped.ImpFrameListSize

function Whipped:Imps_SetupOptions()
	local Imps = {
		name = 'Imps',
		type = 'group',
		args = {
			Thickness = {
				name = 'Thickness',
				order = 1,
				type = 'range',
				min = 2,
				max = 200,
				softMin = 2,
				softMax = 100,
				step = .1,
				set = function(info, input) self.db.global.Imps.Thickness = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.Imps.Thickness end
			},
			Padding = {
				name = 'Padding',
				order = 2,
				type = 'range',
				min = 0,
				max = 200,
				softMin = 0,
				softMax = 100,
				step = .1,
				set = function(info, input) self.db.global.Imps.Padding = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.Imps.Padding end
			},
			Show = {
				name = 'Show',
				type = 'toggle',
				order = 4,
				set =
					function(info, input)
						self.db.global.Imps.Show = input;
						if input == true then
							for k,v in pairs(ImpFrameList) do
								v:Show()
							end
							Frame_Imps_Icon:Show()
						else
							for k,v in pairs(ImpFrameList) do
								v:Hide()
							end
							Frame_Imps_Icon:Hide()
						end
						Whipped:UpdateAllFrames()
					end,
				get =
					function(info)
						return self.db.global.Imps.Show
					end
			},
			Color_1 = {
				name = 'Color 1',
				type = 'color',
				order = 5,
				set =
					function(info, r, g, b, a)
						self.db.global.Imps.Color_1.r = r;
						self.db.global.Imps.Color_1.g = g;
						self.db.global.Imps.Color_1.b = b;
						self.db.global.Imps.Color_1.a = a;
						for i=1, ImpFrameListSize do
							if i % 2 == 0 then
								ImpFrameList[i]:SetStatusBarColor(r,g,b,a)
							end
						end
					end,
				get =
					function(info)
						local color = self.db.global.Imps.Color_1
						return color.r, color.g, color.b, color.a
					end
				
			},
			Color_2 = {
				name = 'Color 2',
				type = 'color',
				order = 5,
				set =
					function(info, r, g, b, a)
						self.db.global.Imps.Color_2.r = r;
						self.db.global.Imps.Color_2.g = g;
						self.db.global.Imps.Color_2.b = b;
						self.db.global.Imps.Color_2.a = a;
						for i=1, ImpFrameListSize do
							if i % 2 ~= 0 then
								ImpFrameList[i]:SetStatusBarColor(r,g,b,a)
							end
						end
					end,
				get =
					function(info)
						local color = self.db.global.Imps.Color_2
						return color.r, color.g, color.b, color.a
					end
				
			},
			Color_Empowered_1 = {
				name = 'Color 1 Empowered',
				type = 'color',
				order = 6,
				set =
					function(info, r, g, b, a)
						self.db.global.Imps.Color_Empowered_1.r = r;
						self.db.global.Imps.Color_Empowered_1.g = g;
						self.db.global.Imps.Color_Empowered_1.b = b;
						self.db.global.Imps.Color_Empowered_1.a = a;
					end,
				get =
					function(info)
						local color = self.db.global.Imps.Color_Empowered_1
						return color.r, color.g, color.b, color.a
					end
				
			},
			Color_Empowered_2 = {
				name = 'Color 2 Empowered',
				type = 'color',
				order = 7,
				set =
					function(info, r, g, b, a)
						self.db.global.Imps.Color_Empowered_2.r = r;
						self.db.global.Imps.Color_Empowered_2.g = g;
						self.db.global.Imps.Color_Empowered_2.b = b;
						self.db.global.Imps.Color_Empowered_2.a = a;
					end,
				get =
					function(info)
						local color = self.db.global.Imps.Color_Empowered_2
						return color.r, color.g, color.b, color.a
					end
				
			},
		}
	}
	self:AddCategory("Imps", Imps)
end

function Whipped:Imps_OnLoad()
	local c1, c2 = Whipped.db.global.Imps.Color_1, Whipped.db.global.Imps.Color_2
	for i=1,ImpFrameListSize do
		ImpFrameList[i]:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
		--ImpFrameList[i]:SetStatusBarTexture("Interface\\Addons\\Whipped\\NameOfCustomTexture")
		ImpFrameList[i]:SetMinMaxValues(0, 12)
		if i % 2 ~= 0 then
			ImpFrameList[i]:SetStatusBarColor(c1.r, c1.g, c1.b, c1.a)
		else
			ImpFrameList[i]:SetStatusBarColor(c2.r, c2.g, c2.b, c2.a)
		end
		ImpFrameList[i]:SetValue(12)
		ImpFrameList[i]:SetFrameLevel(ImpFrameListSize - i + 1)
	end
	
	Frame_Imps_Icon.texture = Frame_Imps_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_Imps_Icon.texture:SetTexture("Interface\\Icons\\spell_warlock_summonimpoutland")
	Frame_Imps_Icon.texture:SetAllPoints(true)
	
	if not self.db.global.Imps.Show then Frame_Imps_1:Hide() --[[; Frame_Imps_Icon:Hide()]] end
end

function Whipped:Imps_OnUpdate()
	local t = GetTime()
	local c1, c2 = Whipped.db.global.Imps.Color_1, Whipped.db.global.Imps.Color_2
	for i=1, ImpFrameListSize do -- Hand of Gul'dan Imp updates
		if Imps.HoG.Wave[i].Summoned == true then
			local val = Imps.HoG.Wave[i].TTL - t
			if val < 0 then
				Imps.HoG.Wave[i].Summoned = false
				Imps.HoG.Wave[i].TTL = 0
				for i=1,ImpFrameListSize do -- Set frame levels so they are correctly layered
					local temp = TopFrame
					if i > TopFrame then
						temp = 1 + ImpFrameListSize + TopFrame - i
					else
						temp = 1 + TopFrame - i
					end
					ImpFrameList[i]:SetFrameLevel(temp)
				end
				TopFrame = TopFrame + 1
				if TopFrame > ImpFrameListSize then TopFrame = 1 end
				val = 12
				Imps.HoG.Wave[i].Dead = 0
				Imps.HoG.Wave[i].IPW = 0
				Imps.HoG.Wave[i].GUID = {}
				if i % 2 ~= 0 then
					ImpFrameList[i]:SetStatusBarColor(c1.r, c1.g, c1.b, c1.a)
				else
					ImpFrameList[i]:SetStatusBarColor(c2.r, c2.g, c2.b, c2.a)
				end
			end
			ImpFrameList[i]:SetValue(val)
		end
	end
	for k,v in pairs(Imps.Doom.Wave) do -- Doom Imp updates
		if v.TTL - t < 0 then
			Imps.Doom.Wave[v.WaveNum] = nil
		end
	end
end

function Whipped:Imps_UpdateFrames()
	local MasterFrame = self.db.global
	local SoulShards = MasterFrame.SoulShards
	local Imps = MasterFrame.Imps
	local anchorID = MasterFrame.Anchor
	local anchor, Oanchor = Whipped.anchors[anchorID], Whipped:OppositeAnchor(anchorID)
	
	local anchorFrame, anchorHelp, x, y = Whipped.Frame_SoulShard_1
	if not SoulShards.Show then anchorFrame = Whipped.MasterFrame end
	
	-- Frame_Imps_Icon
	Frame_Imps_Icon:SetWidth(Imps.Thickness)
	Frame_Imps_Icon:SetHeight(Imps.Thickness)
	Frame_Imps_Icon:ClearAllPoints()
	if anchorID == 1 then
		if SoulShards.Show then
			anchorHelp, x, y = "BOTTOM", 0, -(SoulShards.Padding + Imps.Padding)
		else
			anchorHelp, x, y = "TOP", MasterFrame.PaddingX, -(MasterFrame.PaddingY + Imps.Padding)
		end
		Frame_Imps_Icon:SetPoint(anchor, Frame_Imps_1, Oanchor, MasterFrame.PaddingX, 0)
	elseif anchorID == 2 then
		if SoulShards.Show then
			anchorHelp,x,y = "BOTTOM", 0, -(SoulShards.Padding + Imps.Padding)
		else
			anchorHelp,x,y = "TOP", -MasterFrame.PaddingX, -(MasterFrame.PaddingY + Imps.Padding)
		end
		Frame_Imps_Icon:SetPoint(anchor, Frame_Imps_1, Oanchor, -MasterFrame.PaddingX, 0)
	elseif anchorID == 3 then
		if SoulShards.Show then
			anchorHelp,x,y = "RIGHT", (SoulShards.Padding + Imps.Padding), 0
		else
			anchorHelp,x,y = "LEFT", (MasterFrame.PaddingX + Imps.Padding), -MasterFrame.PaddingY
		end
		Frame_Imps_Icon:SetPoint(anchor, Frame_Imps_1, Oanchor, 0, -MasterFrame.PaddingY)
	elseif anchorID == 4 then
		if SoulShards.Show then
			anchorHelp,x,y = "RIGHT", (SoulShards.Padding + Imps.Padding), 0
		else
			anchorHelp,x,y = "LEFT", (MasterFrame.PaddingX + Imps.Padding), MasterFrame.PaddingY
		end
		Frame_Imps_Icon:SetPoint(anchor, Frame_Imps_1, Oanchor, 0, MasterFrame.PaddingY)
	end
	
	-- Frame_Imps_1-13
	for i=1,ImpFrameListSize do
		ImpFrameList[i]:ClearAllPoints()
		if anchorID == 1 or anchorID == 2 then
			ImpFrameList[i]:SetWidth((SoulShards.Width * 5 + SoulShards.Padding * 4))
			ImpFrameList[i]:SetHeight(Imps.Thickness)
			ImpFrameList[i]:SetPoint("TOP"..anchor, anchorFrame, anchorHelp..anchor, x, y)
			ImpFrameList[i]:SetOrientation("HORIZONTAL")
		else
			ImpFrameList[i]:SetWidth(Imps.Thickness)
			ImpFrameList[i]:SetHeight((SoulShards.Height * 5 + SoulShards.Padding * 4))
			ImpFrameList[i]:SetPoint(anchor.."LEFT", anchorFrame, anchor..anchorHelp, x, y)
			ImpFrameList[i]:SetOrientation("VERTICAL")
		end
	end
end

function Whipped:Imps_CLE(...)
	local Time, event = select(1,...), select(2, ...)
	if strfind(event,"_DAMAGE") ~= nil then
		local overkill
		if event == "SWING_DAMAGE" then overkill = select(13,...) else overkill = select(16,...) end
		if select(9,...) == "Wild Imp" and bit.band(select(10,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 and overkill > -1 then
			Whipped:FindAndDeleteImp(select(8,...))
		end
	elseif event == "SPELL_SUMMON" then
		if bit.band(select(6,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then -- Summoned unit is mine
			local impGUID, spellID = select(8, ...), select(12, ...) -- need the GUIDs for when an imp dies, no pet owner data in 'UNIT_DIED' event
			if spellID == 104317 then -- Triggered by 'Hand of Gul'dan'
				if Imps.HoG.Batch then -- Is a fresh batch
					Imps.HoG.Batch = false
					C_Timer.After(.05, -- Collect all the imps spawned in the last .05 seconds and set as this batch, doesn't work with Fragment of the Dark Star, imps spawn slightly before or after this
						function()
							Imps.HoG.Batch = true
							Imps.HoG.Wave[Bar].TTL = GetTime() + 12
							local IICB = Imps.HoG.IICB
							Imps.HoG.Wave[Bar].IPW = IICB
							Whipped:Cooldown_Legendary(IICB)
							Imps.HoG.IICB = 0
							Imps.HoG.Wave[Bar].Summoned = true
							Imps.HoG.Wave[Bar].DE = 1
							Bar = Bar + 1
							if Bar > ImpFrameListSize then Bar = 1 end
						end)
				end
				Imps.HoG.IICB = Imps.HoG.IICB + 1
				tinsert(Imps.HoG.Wave[Bar].GUID, impGUID) -- Adds all the imp GUIDs spawned from HoG to the list corresponding with the current wave
			elseif spellID == 196273 or spellID == 196274  then -- Triggered by 'Call Dreadstalkers' - Talent: 'Improved Dreadstalkers'
				if Imps.Dreadstalkers.GUID1 == 0 then
					Imps.Dreadstalkers.GUID1 = impGUID
				else
					Imps.Dreadstalkers.GUID2 = impGUID
				end
				if Imps.Dreadstalkers.Batch then -- Is a fresh batch
					Imps.Dreadstalkers.Batch = false
					C_Timer.After(0.05,
						function()
							Imps.Dreadstalkers.Batch = true
							local IICB = Imps.Dreadstalkers.IICB
							Imps.Dreadstalkers.IPW = IICB
							Whipped:Cooldown_Legendary(IICB)
							Imps.Dreadstalkers.IICB = 0
							Imps.Dreadstalkers.DE = 1
						end)
				end
				Imps.Dreadstalkers.IICB = Imps.Dreadstalkers.IICB + 1
			elseif spellID == 196271 then -- Triggered by 'Doom' - Talent: 'Impending Doom'
				if Imps.Doom.Batch then -- Is a fresh batch
					Imps.Doom.Wave[Imps.Doom.CurrentWave] = {
						DE = 1,
						TTL = GetTime() + 12,
						IPW = 0,
						Dead = 0,
						WaveNum = Imps.Doom.CurrentWave, 
						GUID = {}
					}
					Imps.Doom.Batch = false
					C_Timer.After(0.05, 
						function()
							Imps.Doom.Batch = true
							local IICB = Imps.Doom.IICB
							Imps.Doom.Wave[Imps.Doom.CurrentWave].IPW = IICB
							Whipped:Cooldown_Legendary(IICB)
							Imps.Doom.Wave[Imps.Doom.CurrentWave].DE = 1
							Imps.Doom.IICB = 0
							if Imps.Doom.CurrentWave < 1000 then
								Imps.Doom.CurrentWave = Imps.Doom.CurrentWave + 1
							else
								Imps.Doom.CurrentWave = 0
							end
						end)
				end
				Imps.Doom.IICB = Imps.Doom.IICB + 1
				tinsert(Imps.Doom.Wave[Imps.Doom.CurrentWave].GUID, impGUID)
			end
		end
	elseif event == "SPELL_CAST_SUCCESS" then
		local ce1, ce2 = Whipped.db.global.Imps.Color_Empowered_1, Whipped.db.global.Imps.Color_Empowered_2
		for i=1, ImpFrameListSize do
			if Imps.HoG.Wave[i].IPW > 0 then
				if i % 2 == 0 then
					ImpFrameList[i]:SetStatusBarColor(ce1.r, ce1.g, ce1.b, ce1.a)
				else
					ImpFrameList[i]:SetStatusBarColor(ce2.r, ce2.g, ce2.b, ce2.a)
				end
			end
		end
	elseif event == "SPELL_INSTAKILL" then
		local srcFlag, spellID = select(6,...), select(12,...)
		if bit.band(srcFlag, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 and spellID == 196278 then -- Implosion
			Whipped:FindAndDeleteImp(select(8,...))
		end
	end
end

function Whipped:Imps_REGEN_ENABLED(brk)
	if brk > 4 or InCombatLockdown() then return end -- Check to make sure this doesn't repeat itself forever/Re-entered combat.
	if Imps.Alive() == 0 then
		for i=1, ImpFrameListSize do
			ImpFrameList[i]:SetFrameLevel(ImpFrameListSize - i + 1)
		end
		Bar = 1
		TopFrame = 1
	else
		C_Timer.After(4, function() Whipped:Imps_REGEN_ENABLED(brk + 1) end)
	end
end

function Whipped:FindAndDeleteImp(impGUID)
	-- local source = "" -- DEBUG
	local skip = false
	if impGUID == Imps.Dreadstalkers.GUID1 then -- Check Dreadstalker Imps, trigger: _DAMAGE
		Imps.Dreadstalkers.IPW = Imps.Dreadstalkers.IPW - 1
		Imps.Dreadstalkers.Dead = Imps.Dreadstalkers.Dead + 1
		skip = true
	end
	if impGUID == Imps.Dreadstalkers.GUID2 then
		Imps.Dreadstalkers.IPW = Imps.Dreadstalkers.IPW - 1
		Imps.Dreadstalkers.Dead = Imps.Dreadstalkers.Dead + 1
		skip = true
	end
	if not skip then -- Check Doom Imps, trigger: _DAMAGE
		for k,v in pairs(Imps.Doom.Wave) do
			for _k,_v in pairs(v.GUID) do
				if impGUID == _v then
					_v = nil
					v.IPW = v.IPW - 1
					v.Dead = v.Dead + 1
					if #v == 0 then
						v = nil
					end
					skip = true
					break
				end
				if skip then break end
			end
			if skip then break end
		end
	end
	if not skip then -- Check HoG Imps, triggers: _DAMAGE, SPELL_INSTAKILL
		for i=1,ImpFrameListSize do
			for j=1, ImpFrameListSize do -- 4 HoG imps + 3 from Fragment of the Dark Star (possibly)
				if impGUID == Imps.HoG.Wave[i].GUID[j] then
					Imps.HoG.Wave[i].GUID[j] = nil
					Imps.HoG.Wave[i].IPW = Imps.HoG.Wave[i].IPW - 1
					skip = true
					if Imps.HoG.Wave[i].IPW == 0 then	-- Same code as OnUpdate for resetting HoG
						Imps.HoG.Wave[i].TTL = 0
						ImpFrameList[i]:SetValue(12)
						Imps.HoG.Wave[i].Summoned = false
						for i=1,ImpFrameListSize do -- Set frame levels so they are correctly layered
							local temp = TopFrame
							if i > TopFrame then
								temp = 1 + ImpFrameListSize + TopFrame - i
							else
								temp = 1 + TopFrame - i
							end
							ImpFrameList[i]:SetFrameLevel(temp)
						end
						TopFrame = TopFrame + 1
						if TopFrame > ImpFrameListSize then TopFrame = 1 end
						Imps.HoG.Wave[i].Dead = 0
						Imps.HoG.Wave[i].GUID = {}
						local c1, c2 = Whipped.db.global.Imps.Color_1, Whipped.db.global.Imps.Color_2
						if i % 2 ~= 0 then r,g,b,a = c1.r, c1.g, c1.b, c1.a else r,g,b,a = c2.r, c2.g, c2.b, c2.a end
						ImpFrameList[i]:SetStatusBarColor(r,g,b,a)
					end
					if skip then break end
				end
				if skip then break end
			end
			if skip then break end
		end
	end
end

-- Used for Whipped_Dreadstalkers.lua
function Whipped:ImprovedDreadstalkers() -- Used by Whipped:Dreadstalkers_OnUpdate()
	Imps.Dreadstalkers.IPW = 0
	Imps.Dreadstalkers.Dead = 0
	Imps.Dreadstalkers.GUID1 = 0
	Imps.Dreadstalkers.GUID2 = 0
end