if select(3, UnitClass("player")) ~= 9 then return end -- Only load when playing a warlock
local Whipped = _G.Whipped

-- Frames
Whipped.Frame_SoulShard_1 = CreateFrame("StatusBar","SS1",Whipped.MasterFrame)
local Frame_SoulShard_1 = Whipped.Frame_SoulShard_1
local Frame_SoulShard_2 = CreateFrame("StatusBar","SS2",Frame_SoulShard_1)
local Frame_SoulShard_3 = CreateFrame("StatusBar","SS3",Frame_SoulShard_1)
local Frame_SoulShard_4 = CreateFrame("StatusBar","SS4",Frame_SoulShard_1)
local Frame_SoulShard_5 = CreateFrame("StatusBar","SS5",Frame_SoulShard_1)
local Frame_MainDemon_Icon = CreateFrame("FRAME", nil, Frame_SoulShard_1)
local SoulShardsList = {Frame_SoulShard_1, Frame_SoulShard_2, Frame_SoulShard_3, Frame_SoulShard_4, Frame_SoulShard_5}

function Whipped:SoulShards_SetupOptions()
	local SoulShards = {
		name = 'SoulShards',
		type = 'group',
		args = {
			Width = {
				name = 'Width',
				order = 1,
				type = 'range',
				min = 1,
				max = 200,
				softMin = 2,
				softMax = 100,
				step = .1,
				set = function(info, input) self.db.global.SoulShards.Width = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.SoulShards.Width end
			},
			Height = {
				name = 'Height',
				order = 2,
				type = 'range',
				min = 2,
				max = 200,
				softMin = 2,
				softMax = 100,
				step = .1,
				set = function(info, input) self.db.global.SoulShards.Height = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.SoulShards.Height end
			},
			Padding = {
				name = 'Padding',
				order = 3,
				type = 'range',
				min = 0,
				max = 200,
				softMin = 0,
				softMax = 100,
				step = .1,
				set = function(info, input) self.db.global.SoulShards.Padding = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.SoulShards.Padding end
			},
			Show = {
				name = 'Show',
				type = 'toggle',
				order = 4,
				set =
					function(info, input)
						self.db.global.SoulShards.Show = input;
						if input == true then
							Frame_SoulShard_1:Show()
						else
							Frame_SoulShard_1:Hide()
						end
						Whipped:UpdateAllFrames()
					end,
				get =
					function(info)
						return self.db.global.SoulShards.Show
					end
			},
			Color = {
				name = 'Color',
				type = 'color',
				order = 5,
				set =
					function(info, r, g, b, a)
						self.db.global.SoulShards.Color.r = r;
						self.db.global.SoulShards.Color.g = g;
						self.db.global.SoulShards.Color.b = b;
						self.db.global.SoulShards.Color.a = a;
						for i=1, 5 do
							SoulShardsList[i]:SetStatusBarColor(r,g,b,a)
						end
					end,
				get =
					function(info)
						color = self.db.global.SoulShards.Color
						return color.r, color.g, color.b, color.a
					end
				
			}
		}
	}
	self:AddCategory("SoulShards", SoulShards)
end

function Whipped:SoulShards_OnLoad()
	-- Frame_Soulshard_1-5
	local color = self.db.global.SoulShards.Color
	for i=1,5 do
		SoulShardsList[i]:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
		SoulShardsList[i]:SetMinMaxValues(0, 1)
		SoulShardsList[i]:SetStatusBarColor(color.r, color.g, color.b, color.a)
	end
	
	-- Demon Icon	
	Frame_MainDemon_Icon.texture = Frame_MainDemon_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_MainDemon_Icon.texture:SetTexture("Interface\\Icons\\spell_shadow_summonfelguard")
	Frame_MainDemon_Icon.texture:SetAllPoints(true)

	if not self.db.global.SoulShards.Show then Frame_SoulShard_1:Hide() end
end

function Whipped:SoulShards_OnUpdate()
	if self.db.global.SoulShards.Show then
		local up, bShard_Active = UnitPower("player", 7)
		for i=1, 5 do
			if i <= up then bShard_Active = 1 else bShard_Active = 0 end
			SoulShardsList[i]:SetValue(bShard_Active)
		end
	end
end

function Whipped:SoulShards_UpdateFrames()
	local MasterFrame = self.db.global -- Global options
	local SoulShards = MasterFrame.SoulShards -- Soulshard options
	local anchorID = MasterFrame.Anchor
	local anchor, Oanchor = Whipped.anchors[anchorID], Whipped:OppositeAnchor(anchorID)
	
	-- Frame_MainDemon_Icon
	Frame_MainDemon_Icon:ClearAllPoints()
	if anchorID == 1 then
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Height)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Height)
		Frame_MainDemon_Icon:SetPoint("TOPLEFT", Frame_SoulShard_5, "TOPRIGHT", MasterFrame.PaddingX, 0)
	elseif anchorID == 2 then
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Height)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Height)
		Frame_MainDemon_Icon:SetPoint("TOPRIGHT", Frame_SoulShard_5, "TOPLEFT", -MasterFrame.PaddingX, 0)
	elseif anchorID == 3 then
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Width)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Width)
		Frame_MainDemon_Icon:SetPoint("TOPLEFT", Frame_SoulShard_5, "BOTTOMLEFT", 0, -MasterFrame.PaddingY)
	elseif anchorID == 4 then
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Width)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Width)
		Frame_MainDemon_Icon:SetPoint("BOTTOMLEFT", Frame_SoulShard_5, "TOPLEFT", 0, MasterFrame.PaddingY)
	end
	
	-- Frame_Soulshards_1-5
	for i=1,5 do
		SoulShardsList[i]:SetWidth(SoulShards.Width)
		SoulShardsList[i]:SetHeight(SoulShards.Height)
	end
	
	SoulShardsList[1]:ClearAllPoints()
	if anchorID == 1 then
		SoulShardsList[1]:SetPoint("TOP"..anchor, Whipped.MasterFrame, "TOP"..anchor, MasterFrame.PaddingX, -(MasterFrame.PaddingY + SoulShards.Padding))
	elseif anchorID == 2 then
		SoulShardsList[1]:SetPoint("TOP"..anchor, Whipped.MasterFrame, "TOP"..anchor, -MasterFrame.PaddingX, -(MasterFrame.PaddingY + SoulShards.Padding))
	elseif anchorID == 3 then
		SoulShardsList[1]:SetPoint(anchor.."LEFT", Whipped.MasterFrame, anchor.."LEFT", (MasterFrame.PaddingX + SoulShards.Padding), -MasterFrame.PaddingY)
	elseif anchorID ==4 then
		SoulShardsList[1]:SetPoint(anchor.."LEFT", Whipped.MasterFrame, anchor.."LEFT", (MasterFrame.PaddingX + SoulShards.Padding), MasterFrame.PaddingY)
	end
	for i=1,4 do
		SoulShardsList[i+1]:ClearAllPoints()
		if anchorID == 1 then
			SoulShardsList[i+1]:SetPoint("TOP"..anchor, "SS"..i, "TOP"..Oanchor, SoulShards.Padding, 0)
		elseif anchorID == 2 then
			SoulShardsList[i+1]:SetPoint("TOP"..anchor, "SS"..i, "TOP"..Oanchor, -SoulShards.Padding, 0)
		elseif anchorID == 3 then
			SoulShardsList[i+1]:SetPoint(anchor.."LEFT", "SS"..i, Oanchor.."LEFT", 0, -SoulShards.Padding)
		elseif anchorID ==4 then
			SoulShardsList[i+1]:SetPoint(anchor.."LEFT", "SS"..i, Oanchor.."LEFT", 0, SoulShards.Padding)
		end
	end
end

function Whipped:SoulShards_SetGlow(flag)
	if flag then
		ActionButton_ShowOverlayGlow(Frame_MainDemon_Icon)
	else
		ActionButton_HideOverlayGlow(Frame_MainDemon_Icon)
	end
end